.nolist	; prevents listing of includes
.386
.model flat, stdcall
option casemap :none
 
include     \masm32\include\windows.inc
include     \masm32\include\kernel32.inc
include     \masm32\include\user32.inc

includelib  \masm32\lib\kernel32.lib
includelib  \masm32\lib\user32.lib

.list

.code

LibMain     PROC   instance:DWORD,reason:DWORD,unused:DWORD 

    mov     eax,1
    ret

LibMain     ENDP

OPTION      PROLOGUE:NONE 
OPTION      EPILOGUE:NONE 

align 4

StrLen      PROC EXPORT item:DWORD

    mov     eax,[esp+4]
    push    ebx
    lea     edx,[eax+3]

@@:     

    mov     ebx,[eax]
    add     eax, 4
    lea     ecx,[ebx-01010101h]
    not     ebx
    and     ecx,ebx
    and     ecx, 80808080h
    jz      @B

    test    ecx,00008080h
    jnz     @F
    shr     ecx,16
    add     eax,2

@@:

    shl     cl,1
    sbb     eax,edx
    pop     ebx
    ret     4

StrLen      ENDP

OPTION      PROLOGUE:PrologueDef 
OPTION      EPILOGUE:EpilogueDef 

locate      PROC EXPORT x:DWORD,y:DWORD ; function from masm32.lib

    LOCAL   hOutPut  :DWORD
    LOCAL   xyVar    :DWORD

    invoke  GetStdHandle,STD_OUTPUT_HANDLE
    mov     hOutPut, eax

    mov     ecx, x
    mov     eax, y
    shl     eax, 16
    mov     ax, cx

    invoke  SetConsoleCursorPosition,hOutPut,eax
    ret

locate      ENDP

TellMe PROC EXPORT tm_dlg,tm_txt,tm_title,tm_mb

    invoke MessageBox,tm_dlg,tm_txt,tm_title, tm_mb
    ret

TellMe ENDP

StdOut      PROC EXPORT lpszText:DWORD ; function from masm32.lib

    LOCAL   hOutPut  :DWORD
    LOCAL   bWritten :DWORD
    LOCAL   sl       :DWORD

    invoke  GetStdHandle,STD_OUTPUT_HANDLE
    mov     hOutPut, eax

    invoke  StrLen,lpszText
    mov     sl, eax

    invoke  WriteFile,hOutPut,lpszText,sl,ADDR bWritten,NULL

    mov     eax, bWritten
    ret

StdOut      ENDP

ClearScreen PROC EXPORT    ; from masm32.lib

    LOCAL   hOutPut:DWORD
    LOCAL   noc    :DWORD
    LOCAL   cnt    :DWORD
    LOCAL   sbi    :CONSOLE_SCREEN_BUFFER_INFO

    invoke  GetStdHandle,STD_OUTPUT_HANDLE
    mov     hOutPut, eax

    invoke  GetConsoleScreenBufferInfo,hOutPut,ADDR sbi

    mov     eax, sbi.dwSize

    push    ax
    rol     eax, 16
    mov     cx, ax
    pop     ax
    mul     cx
    cwde
    mov     cnt, eax

    invoke  FillConsoleOutputCharacter,hOutPut,32,cnt,NULL,ADDR noc

    invoke  locate,0,0
    ret
    
ClearScreen ENDP

END         LibMain

OPT_LINKER	link	; polink will fail for this dll
OPT_RUN	; put %oBody%.exe to test run your baby after assembly
OPT_ARG1	"Hi jj2007, what a nice tool!"
OPT_ARG2	"This demo is run from A Simple DLL"

; check AsmB_tmp.bat on how these two lines are inserted:
OPT_RUN_BEFORE_LINK=call SayHi "Now linking %oBody%"
OPT_RUN_AFTER_LINK=call Have_a_Break "Linked ok"

OPT_LINK	; blank for defaults
OPT_ASM	; blank for defaults
OPT_RES	; e.g. rsrc.obj - leave blank if you don't use them
OPT_SUSY	CONSOLE ; Subsystem; default is WINDOWS, use CONSOLE if needed
OPT_TGT	dll ; default is exe, use dll if needed

OPT_CLEANLIB 1 ; leave blank if you need *.lib file
OPT_CLEANEXP 1 ; leave blank if you need *.exp file
OPT_CLEANDEF   ; leave blank if you need to debug with \Masm32\Dll_temp.bat
OPT_LOG	; dll_log.txt ; remove ";" before dll_log.txt to log the options
